import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.skt.m.*;


public class PinkDialog implements XTimerListener
{

/*
** --------------------------------------------------------------------------------
**	 	    
** --------------------------------------------------------------------------------
*/
	public final static char CARRIAGE_RETURN	= '\n';	// CARRIAGE_RETURN

	public int DIALOG_PER_HEIGHT = PinkCanvas.LCD_FHEIGHT;		// Dialog  ٴ 
	public int DIALOG_WIDTH;		// Dialog  
	public int DIALOG_HEIGHT;		// Dialog  
	public int DIALOG_X;			// Dialog  X
	public int DIALOG_Y;			// Dialog  Y

	char[] dialog_text;
	char[] dialog_subject;
	int[] dialog_line = new int[5];

	PinkCanvas pinkCanvas;
	XTimer xTimerDialog;

	
/*
** --------------------------------------------------------------------------------
**	Լ 	    
** --------------------------------------------------------------------------------
*/


/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    PinkDialog
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** --------------------------------------------------------------------------------
*/

	PinkDialog(PinkCanvas pinkCanvas)
	{
		this.pinkCanvas = pinkCanvas;

		// ڵ Ű ..
		xTimerDialog = new XTimer(2000);
		xTimerDialog.setTimerListener(this);
		xTimerDialog.start();
		xTimerDialog.cancel();
	}


/*
** --------------------------------------------------------------------------------
**  Function:
** 	    performed
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public void performed(XTimer aXTimer)
	{
		pinkCanvas.keyPressed(Canvas.KEY_COMR);
		xTimerDialog.cancel();
	}



/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    setChars
**
**  Description: 
** 	    Dialog  
**
**  Input:	
** 		text : 
** 		line : 
** 
**  Return value:
**	    
** --------------------------------------------------------------------------------
*/


	public void setChars(char[] subject, char[] _dialog_text)
	{
		int i = 0, j = 0, lenChars;

		if(_dialog_text == null)
			throw new IllegalArgumentException();

		if(dialog_text != null)
		{
			dialog_text = null;

			lenChars = dialog_line.length;
			
			for(i = 0; i < lenChars; i++)
				dialog_line[i] = 0;
		}

		if(dialog_subject != null)
			dialog_subject = null;

		lenChars = subject.length;
		dialog_subject = new char[lenChars];
		System.arraycopy(subject, 0, dialog_subject, 0, lenChars);

		lenChars = _dialog_text.length;
		dialog_text = new char[lenChars];
		System.arraycopy(_dialog_text, 0, dialog_text, 0, lenChars);

		DIALOG_WIDTH = 82;			// Dialog 

		int widthChars = 0;
	
		for(i = 0, j = 0; i < lenChars; i++)
		{
			if(dialog_text[i] == CARRIAGE_RETURN || i + 1 == lenChars)
			{
				dialog_line[j++] = i + 1;
				widthChars = 0;
				continue;
			}

			widthChars += Toolkit.DEFAULT_FONT.charWidth(dialog_text[i]);

			if(widthChars > (DIALOG_WIDTH - 4))
			{
				dialog_line[j++] = i--;
				widthChars = 0;
			}
		}

		DIALOG_HEIGHT = 48 + DIALOG_PER_HEIGHT * j;		// Dialog  
		DIALOG_X = (pinkCanvas.getWidth() - DIALOG_WIDTH) / 2;				// Dialog  X
		DIALOG_Y = (pinkCanvas.getHeight() + 16 - DIALOG_HEIGHT) / 2;			// Dialog  Y
}


/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    paint
**
**  Description: 
** 	    Dialog ü ȭ鿡 ׸.
**
**  Input:	
** 		text : 
** 		line : 
** 
**  Return value:
**	    
** --------------------------------------------------------------------------------
*/
	public void paint(Graphics g)
	{
		//  ׸..
		g.setColor(0xffffff);
		g.fillRect(DIALOG_X, DIALOG_Y, DIALOG_WIDTH, DIALOG_HEIGHT);

		//  ׵θ.
		g.setColor(0x000000);
		g.drawRect(DIALOG_X + 1, DIALOG_Y + 1, DIALOG_WIDTH - 3, DIALOG_HEIGHT - 3);

		//  
		g.setColor(0xb6dbff);
		g.fillRect(DIALOG_X + 4, DIALOG_Y + 4, 74, 13);

		// 
		g.setColor(0x000000);
		g.drawLine(DIALOG_X + 4, DIALOG_Y + 19, 
			DIALOG_X + DIALOG_WIDTH - 5, DIALOG_Y + 19);

		//  
		g.setColor(0x920000);
		g.drawChars(dialog_subject, 0, dialog_subject.length, 
			pinkCanvas.getWidth() / 2, DIALOG_Y + 3, g.HCENTER | g.TOP);

		//  
		g.setColor(0x000000);
		for(int i = 0 ; dialog_line[i] > 0; i++)
		{
			if(i == 0)
			{
				g.drawChars(dialog_text, 0, dialog_line[i], pinkCanvas.getWidth() / 2, 
					DIALOG_Y + 23 + DIALOG_PER_HEIGHT * i + 8, g.HCENTER | g.TOP);
				
				continue;
			}
			
			g.drawChars(dialog_text, dialog_line[i - 1], dialog_line[i] - dialog_line[i - 1], pinkCanvas.getWidth() / 2, 
				DIALOG_Y + 23 + DIALOG_PER_HEIGHT * i + 8, g.HCENTER | g.TOP);
		}

		xTimerDialog.resume();
	}
}
