/**
 * Title:PinkPopup.java
 * Description:
 * Copyright:Copyright (c) 2004
 * Company:xce
 * Create Date:2004.2.19
 * modify Date:
 * @author pinkred
 * @version 
 *
 */
 
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import java.io.*;

import com.xce.lcdui.*;
import com.skt.m.*;
import com.xce.io.*;


public class PinkPopup
{
/* 
**----------------------------------------------------------------------------
**  Definitions
**----------------------------------------------------------------------------
*/


	public final static int POPUP_PER_HEIGHT	= PinkCanvas.LCD_FHEIGHT;	// ٴ 

/* 
**----------------------------------------------------------------------------
**  Struct Definitions
**----------------------------------------------------------------------------
*/

	int POPUP_X;					
	int POPUP_Y;	
	int POPUP_WIDTH;		// .
	int POPUP_HEIGHT;		// ..
	
	private char[][] popup_list;	// ˾ Ʈ
	int popup_numTot;	// 
	int popup_select;	// õȰ

	char[] popup_num = {'', '', '', '', '', '', '', '', ''};

	PinkCanvas pinkCanvas;
	

	PinkPopup(PinkCanvas pinkCanvas)
	{
		this.pinkCanvas = pinkCanvas;
	}

/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    popup_setChars
**
**  Description: 
** 	    ˾â ʱȭ.
**
**  Input:
**
**		**_popup_list
**
**		_popup_numTot
**
** 		    
**  Return value:
** 
** --------------------------------------------------------------------------------
*/

	public void setChars(char[][] _popup_list, int _popup_numTot)
	{
		if(_popup_list == null)
			return;

		int i = 0;
		int lenStr = 0;
		int popup_width = 0, lenWidth = 0;
		
		if(popup_list != null)
		{
			for(i = 0; i < popup_numTot; i++)
				popup_list[i] = null;

			popup_list = null;
			popup_numTot = 0;
		}
		
		popup_numTot = _popup_numTot;
		popup_list = new char[popup_numTot][];
		
		for(i = 0; i < popup_numTot; i++)
		{
			lenStr = _popup_list[i].length;
			popup_list[i] = new char[lenStr];

			System.arraycopy(_popup_list[i], 0, popup_list[i], 0, lenStr);

			lenWidth = Toolkit.DEFAULT_FONT.charsWidth(popup_list[i], 0, popup_list[i].length);

			if(popup_width < lenWidth)
				popup_width = lenWidth;
		}
		
		popup_select = 0;

		POPUP_HEIGHT = POPUP_PER_HEIGHT * popup_numTot + 10;	// Ʒ .
		POPUP_WIDTH = popup_width + 22;		//
		POPUP_X = pinkCanvas.LCD_X;					
		POPUP_Y = pinkCanvas.LCD_Y + PinkCanvas.LCD_HEIGHT - PinkCanvas.LCD_SOFTBAR - POPUP_HEIGHT + 1;
	}

/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    popup_getSelect
**
**  Description: 
** 	     õ ˾ Ʈ.
**
**  Input:
** 		    
**  Return value:
** 
** --------------------------------------------------------------------------------
*/

	public int getSelect()
	{
		return popup_select;
	}

/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    popup_getLast
**
**  Description: 
** 	    ˾Ʈ .
**
**  Input:
** 		    
**  Return value:
** 
** --------------------------------------------------------------------------------
*/

	public int getCount()
	{
		return popup_numTot;
	}


/*
** -------------------------------------------------------------------------
**  Function:
** 	    paint
**
**  Description:
** 	    List  ׸.
**
**  Input:
** 	g : Graphics ü
**
**  Return value:
**
** -------------------------------------------------------------------------
*/
	public void paint(Graphics g)
	{
		// ׵θ ׸
		g.setColor(0x327ab8);
		g.drawRect(POPUP_X, POPUP_Y, POPUP_WIDTH - 1, POPUP_HEIGHT - 1);

		//   
		g.setColor(0xffffff);
		g.fillRect(POPUP_X + 1, POPUP_Y + 1, POPUP_WIDTH - 2, POPUP_HEIGHT - 2);

		//  Ķ 
		g.setColor(0xb6dbff);
		g.fillRect(POPUP_X + 3, POPUP_Y + 3, POPUP_WIDTH - 6, POPUP_HEIGHT - 6);

		//   Ʈ ׸
		for(int i = 0; i < popup_numTot; i++)
		{	
			if(popup_select == i)
			{		
				g.setColor(0xffffff);
				g.fillRect(POPUP_X + 3, POPUP_Y + 5 + (POPUP_PER_HEIGHT * i), 
					POPUP_WIDTH - 6, POPUP_PER_HEIGHT);

				g.setColor(0x920000);
				g.drawChar(popup_num[i], POPUP_X + 5, POPUP_Y + 5 + (POPUP_PER_HEIGHT * i), g.LEFT | g.TOP);
				g.drawChars(popup_list[i], 0, popup_list[i].length, 
					POPUP_X + 17, POPUP_Y + 5 + POPUP_PER_HEIGHT * i, g.LEFT | g.TOP);
				continue;
			}
			
			g.setColor(0x920000);
			g.drawChar(popup_num[i], POPUP_X + 5, POPUP_Y + 5 + (POPUP_PER_HEIGHT * i), g.LEFT | g.TOP);
			g.drawChars(popup_list[i], 0, popup_list[i].length, 
				POPUP_X + 17, POPUP_Y + 5 + POPUP_PER_HEIGHT * i, g.LEFT | g.TOP);
		}

		// ϴ Ʈ ׸.
		pinkCanvas.pinkSoftBar.paint(g, PinkSoftBar.XSOFTBAR_CANCEL, PinkSoftBar.XSOFTBAR_NONE, PinkSoftBar.XSOFTBAR_ENTER);
	}


/*
** -------------------------------------------------------------------------
**  Function:
** 	    keyPressed
**
**  Description:
**		key ̺Ʈ.
**
**  Input:
** 	keyCode : Ű.
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void keyPressed(int keyCode)
	{
		switch(keyCode)					
		{
			case Canvas.KEY_NUM1:		// 	= 49;
			case Canvas.KEY_NUM2:		// 	= 50;
			case Canvas.KEY_NUM3:		// 	= 51;
			case Canvas.KEY_NUM4:		// 	= 52;
			case Canvas.KEY_NUM5:		// 	= 53;
			case Canvas.KEY_NUM6:		// 	= 54;
			case Canvas.KEY_NUM7:		// 	= 55;
			case Canvas.KEY_NUM8:		// 	= 56;
			case Canvas.KEY_NUM9:		// 	= 57;
				if(keyCode - Canvas.KEY_NUM1 < popup_numTot)
					popup_select = keyCode - Canvas.KEY_NUM1;
				break;

			case Canvas.KEY_COML:		//	= 129;
			case Canvas.KEY_COMR:		//	= 131;
//			case Canvas.KEY_CLR:			//	= 8;
//			case Canvas.KEY_FIRE:		//	= 148;	Nate Key	
				if(popup_list != null)
				{
					for(int i = 0; i < popup_numTot; i++)
						popup_list[i] = null;

					popup_list = null;
//					popup_numTot = 0;
				}
				break;


			case Canvas.KEY_UP:			//	= 141;
				popup_select = (popup_select <= 0)?popup_numTot - 1:--popup_select;
				pinkCanvas.setRefreshArea(POPUP_X, POPUP_Y, POPUP_WIDTH, POPUP_HEIGHT);
				pinkCanvas.repaintArea();
				break;
				
			case Canvas.KEY_DOWN:		//	= 146;
				popup_select = (popup_select >= popup_numTot - 1)?0:++popup_select;
				pinkCanvas.setRefreshArea(POPUP_X, POPUP_Y, POPUP_WIDTH, POPUP_HEIGHT);
				pinkCanvas.repaintArea();
				break;
		}
	}


/*
** -------------------------------------------------------------------------
**  Function:
** 	    keyReleased
**
**  Description:
**		key ̺Ʈ.
**
**  Input:
** 	keyCode : Ű.
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void keyReleased(int keyCode)
	{
		switch(keyCode)
		{
			case Canvas.KEY_NUM1:		// 	= 49;
			case Canvas.KEY_NUM2:		// 	= 50;
			case Canvas.KEY_NUM3:		// 	= 51;
			case Canvas.KEY_NUM4:		// 	= 52;
			case Canvas.KEY_NUM5:		// 	= 53;
			case Canvas.KEY_NUM6:		// 	= 54;
			case Canvas.KEY_NUM7:		// 	= 55;
			case Canvas.KEY_NUM8:		// 	= 56;
			case Canvas.KEY_NUM9:		// 	= 57;
				if(keyCode - Canvas.KEY_NUM1 < popup_numTot)
					pinkCanvas.keyPressed(Canvas.KEY_COMR);
				break;
		}
	}
}
