/**
 *   ϴ Ŭν 带 Ѵ.
 *
 *   1. Ŭ Ѵ.
 *        2.   ͸ Ѵ. -> setMusic(byte[] data);
 *        3. ָ Ѵ.                 -> play();
 *         ͸ ѵ close(); ϱ  ش      ִ.
 *        4. stop();  ȣϸ  Ѵ.
 *        5. close(); ȣ ϸ   Ͱ reset ȴ.
 *        6. dispose(); ȣϸ  ڿ ݳѴ. ( : ̰  Ȱ Ҽ  Ѵ.)
 */

import javax.microedition.io.*;
import java.io.*;
import com.xce.io.*;
import com.skt.m.*;

public class XSound implements Runnable {

	private Thread runner;			// Thread
	private boolean isRun; 			//  Thread running 
	private Object lockObject;		// Thread Lock Object
	private boolean isActivate;		//  Timer Ȱ 
	private AudioClip clip;			//  
	private int currentVolume;		//  
	private int currentID;			//    ID (  ˻縦  )
	private int MAX_VOLUME;		// MMF ִ 
	private static final String MEDIA_TYPE = "mmf";    // Audio Type

	/**
	 * 
	 */

	public XSound() {

		try {

			MAX_VOLUME = AudioSystem.getMaxVolume(MEDIA_TYPE);
			currentVolume = AudioSystem.getMaxVolume(MEDIA_TYPE) / 2;
			AudioSystem.setVolume(MEDIA_TYPE, currentVolume);
			clip = AudioSystem.getAudioClip(MEDIA_TYPE);

		} catch (Exception e) {}

		lockObject = new Object();
		runner = new Thread(this);
		isRun = true;
		isActivate = false;
		currentID = -1;
		runner.start();

	} // end public MMFPlayer()

	/**
	 *   ͸  ش.
	 *
	 * @param data   
	 * @param ID  ̵ (  )
	 */

	public void setData(byte[] data, int ID) {

		try {

			currentID = ID;
			stop();
			clip.open(data, 0, data.length);

		} catch (Exception e) {}

	} // end public void setData(byte[] data, int ID)

	/**
	 *     ̵  ( ؼ  ֵ  ̵ )
	 *
	 * @return     ̵
	 */

	public int getID() {

		return currentID;

	} // end public int getID()

	/**
	 *  
	 */

	public void run() {

		while (isRun) {

			try {

				synchronized (lockObject) {

					while (isActivate == false) {

						lockObject.wait(100000);

					} // end while (isActivate == false)

				} // synchronized (lockObject)

				clip.play();
				isActivate = false;

			} catch (Exception e) {}

		} // end while(isRun)

	} // end public void run()

	/**
	 *  Ѵ.
	 */

	public void play() {

		isActivate = true;

		synchronized (lockObject) {

			lockObject.notify();

		} // end synchronized (lockObject)

	} // end public void play()

	/**
	 *  
	 */

	public void stop() {

		try {

			isActivate = false;
			clip.stop();

		} catch (Exception e) {}

	} // end public void stop()

	/**
	 *  ݴ´.
	 */

	public void close() {

		try {

			stop();
			clip.close();

		} catch (Exception e) {}

	} // end public void close()

	/**
	 * Ŭ ڿ ݳѴ.
	 * ( : ̰  Ȱ Ҽ  Ѵ.)
	 */

	public void dispose() {

		close();
		isRun = false;

		try {

			runner.join(500);

		} catch (Exception e) {}

		runner = null;
		clip = null;
		lockObject = null;

	} // end public void dispose()

	/**
	 * Volume Ѵܰ δ.
	 */

	public void volumeUp() {

		try {

			if (currentVolume - 1 < MAX_VOLUME) {

				AudioSystem.setVolume(MEDIA_TYPE, ++currentVolume);

			} // end if (AudioSystem.getVolume(MEDIA_TYPE) - 1 < MAX_VOLUME)

		} catch (Exception e) {}

	} // end public void volumeUp()

	/**
	 * Volume Ѵܰ .
	 */

	public void volumeDown() {

		try {

			if (currentVolume > 0) {

				AudioSystem.setVolume(MEDIA_TYPE, --currentVolume);

			} // end if (currentVolume > 0)

		} catch (Exception e) {}

	} // end public void volumeDown()

} // end class MMFPlayer