/**
 * <p>Title:  °</p>
 * <p>Description: Ÿ Ʈũ °</p>
 * <p>Copyright: Copyright XCE(c) 2003</p>
 * <p>Company: XCE</p>
 * @author Rushipel
 * @version 1.0
 */

import java.util.*;

public class XTimer implements Runnable {

	private Thread runner;                   //   óϴ Thread
	private boolean isRun;                   //  Thread running 
	private long time;                       // timer ð
	private Object lockObject;               // Thread Lock Object
	private boolean isActivate;              //  Timer Ȱ 
	private boolean isCancel;                // Timer   
	private boolean isWait;                  // Thread   
	private int loopCount;                   // ݺ Ƚ
	private int currentLoopCount;            //  ݺ Ƚ
	private XTimerListener aXTimerListener;  // Ÿ̸ ó ü

	/**
	 * 
	 */

	public XTimer() {

		this(0L);

	} // end public XTimer()

	/**
	 * 
	 *
	 * @param time Ÿ̸ ð
	 */

	public XTimer(long time) {

		this.time = time;
		lockObject = new Object();
		loopCount = 0;
		currentLoopCount = 0;

	} // end public XTimer(long time)

	/**
	 * ݺ Ƚ 
	 *
	 * @param count ݺ Ƚ (0 ϶  )
	 */

	public void setLoopCount(int count) {

		loopCount = count;
		currentLoopCount = 0;

	} // end public void setLoopCount(int count)

	/**
	 * timer ð  ´.
	 *
	 * @return timer ð
	 */

	public long getTime() {

		return time;

	} // end public long getTime()

	/**
	 * timer ð  Ѵ.
	 *
	 * @param time  timer ð
	 */

	public void setTime(long time) {

		this.time = time;

	} // end public void setTime(int time)

	/**
	 * Priority Ѵ.
	 *
	 * @param priority  Priority
	 */

	public void setPriority(int priority) {

		runner.setPriority(priority);

	} // end public void setPriority(int priority)

	/**
	 * Ÿ̸ ̺Ʈ  ü Ѵ.
	 *
	 * @param aTimerListener Ÿ̸ ̺Ʈ  ü
	 */

	public void setTimerListener(XTimerListener aTimerListener) {

		this.aXTimerListener = null;
		this.aXTimerListener = aTimerListener;

	} // end public void setTimerListener(XTimerListener aTimerListener)

	/**
	 * Thread ٸ Ѵ.
	 */

	public void pause() {

		isActivate = false;

	} // end public void puase()

	/**
	 * Thread 簳 Ų.
	 */

	public void resume() {

		isActivate = true;

		// Thread     ش.
		if (isWait) {

			synchronized (runner) {

				isCancel = true;
				runner.notify();

			} // end synchronized (runner)

		} // end if (isWait)

		synchronized (lockObject) {

			lockObject.notify();

		} // end synchronized (lockObject)

	} // end public void resume()

	/**
	 * Thread  Ų.
	 */

	public void cancel() {

		isCancel = true;
		isActivate = false;
	
		// Thread     ش.
		if (isWait) {

			synchronized (runner) {

				runner.notify();

			} // end synchronized (runner)

			try { Thread.sleep(100); } catch (Exception e) {}

		} // end if (isWait)

	} // end public void cancel()

	/**
	 *  Thread Ȱ ¸ Ѵ.
	 *
	 * @return  Thread Ȱ 
	 */

	public boolean isActivate() {
		return (isActivate && isRun) ? true : false;

	} // end public boolean isActivate()

	/**
	 * Thread Ѵ.
	 */

	public void start() {

		//  Thread Ͽ Ѵ.
		if (runner == null) {

			runner = new Thread(this);
			isRun = true;
			runner.start();
			isActivate = true;

		} // end if (runner == null)

		else {

			stop();
			start();

		} // end else

	} // end public void start()

	/**
	 * Thread Ѵ.
	 */

	public void stop() {

		if (runner != null) {

			cancel();
			isRun = false;
			isActivate = false;

			// Thread Ҷ Ѵ.

			try { runner.join(1000); } catch(Exception e) {}

			//   ÷  ŷѴ.
			runner = null;

		} // end if (runner != null)

	} // end public void stop()

	/**
	 * Ÿ̸ Ȯ
	 */

	public void run() {

		while (isRun) {

			synchronized (lockObject) {

				try {

					while (isActivate == false) {

						lockObject.wait(100000);

					} // end while (isActivate == false)

					isWait = true;

				} catch (Exception e) {}

			} // synchronized (lockObject)

			synchronized (runner) {

				try {

					if (time > 0) {

						runner.wait(time);

					} // end if (time > 0)

					runner.yield();

				} catch (Exception e) {}

			} // end synchronized (runner)

			isWait = false;

			//   
			if (isCancel) {

				isCancel = false;

			} // end if (isCancel)

			else {

				performed();

				// loopCount 0 ϶  .
				if (loopCount > 0) {

					currentLoopCount++;

					// ŭ  ٸ.
					if (currentLoopCount >= loopCount) {

						isActivate = false;

					} // end if (currentLoopCount >= loopCount)

				} // end if (loopCount > 0)

			} // end else

		} // end while(isRun)

	} // end public void run()

	/**
	 * ̺Ʈ Ѵ.
	 */

	private void performed() {

		if (aXTimerListener != null) {

			aXTimerListener.performed(this);

		} // end if (aTimerListener != null)

	} // end private void actionPerformed()

} // end class XTimer
