import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class TorusRing
{
	public final static int GAME_LEVEL = 9;

	int x;			// Torus X
	int y;			// Torus Y
	int color;		// Torus .
	int motion;		// Torus ִ
	int selSlot;		// ش Torus .
	int speed;		// Torus  ǵ

	Random random;
	TorusCanvas tCanvas;
	

/*
** -----------------------------------------------------------------
**  Function:    
** 	    TorusRing
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	
	TorusRing(TorusCanvas tCanvas)
	{
		this.tCanvas = tCanvas;
	}

/*
** -----------------------------------------------------------------
**  Function:    
** 	    setStaus
**
**  Description: 
** 	    ¸ ʱȭ Ų.
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public void setStaus(int selSlot)
	{
		//  
		this.selSlot = selSlot;

		// ִϸ̼ ó
		motion = 0;

		// Į μ
		//  ߾ȵȴٴ..
		random = new Random();
		
		random.setSeed(System.currentTimeMillis());
		color = Math.abs(random.nextInt() + selSlot) % TorusCanvas.MAX_COLOR;

		// ,    ǵ尡 ٸ.
		speed = ((color + 1) * TorusCanvas.MAX_COLOR) % GAME_LEVEL;

		// X, Y  
		x = tCanvas.tEngine.SLOT_X + 1 + (TorusEngine.TORUS_WIDTH + 1) * selSlot;
		y = TorusCanvas.MOTION_Y;

		random = null;
	}



/*
** -----------------------------------------------------------------
**  Function:    
** 	    paint
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public int paint(Graphics g)
	{
		//  Torus ġ  ŭ  .
		g.setColor(0x000000);
		g.fillRect(x, y, TorusEngine.TORUS_WIDTH, TorusEngine.TORUS_HEIGHT);

		//   Ѵ.  ũ ׸ŭ  .
		y += speed;

		// ش   ִϸ̼ǿ ´ Torus ׸.
		tCanvas.g2.drawImage(x, y,
			tCanvas.imgTorus,
			TorusEngine.TORUS_WIDTH * color,
			TorusEngine.TORUS_HEIGHT * (motion++ % TorusEngine.TORUS_MOTION),
			TorusEngine.TORUS_WIDTH, TorusEngine.TORUS_HEIGHT, Graphics2D.DRAW_COPY);

		// Torus Կ ϸ..
		if(y >= tCanvas.tEngine.SLOT_Y)
		{
			// ť ġ  ..
			if(!tCanvas.tEngine.slotPut(selSlot, color + 1))
				return -1;

			// ٽ  ø.
			setStaus(selSlot);
			return 1;
		}

		return 0;
	}
}
