import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.skt.m.*;

public class PinkSoftBar
{

/*
** --------------------------------------------------------------------------------
**	Define 	    
** --------------------------------------------------------------------------------
*/

	public final static int XSOFTBAR_NONE		= -1;	// ư 
	public final static int XSOFTBAR_UP			= 0;	// 
	public final static int XSOFTBAR_ENTER		= 1;	// Ȯ
	public final static int XSOFTBAR_MENU		= 2;	// ޴
	public final static int XSOFTBAR_LOGIN		= 3;	// α
	public final static int XSOFTBAR_JOIN			= 4;	// 
	public final static int XSOFTBAR_CANCEL		= 5;	// 	
	public final static int XSOFTBAR_4ARROW		= 6;	// 4 ȭǥ
	public final static int XSOFTBAR_2ARROW		= 7;	//  ȭǥ
	public final static int XSOFTBAR_SEND		= 8;	// 
	public final static int XSOFTBAR_MYHOME		= 9;	//  Ȩ
	public final static int XSOFTBAR_CALL			= 10;// ȭ ư.

	public final static int SOFTBAR_WIDTH 	= PinkCanvas.LCD_WIDTH;
	public final static int SOFTBAR_HEIGHT 	= PinkCanvas.LCD_SOFTBAR;
	public final static int SOFTBAR_X 			= PinkCanvas.LCD_X;
	public final static int SOFTBAR_Y 			= PinkCanvas.LCD_Y + PinkCanvas.LCD_HEIGHT - PinkCanvas.LCD_SOFTBAR;
	public final static int SOFTBAR_TEXT_Y 	= SOFTBAR_Y + (SOFTBAR_HEIGHT - PinkCanvas.LCD_FHEIGHT) / 2 + 1;
	
	PinkCanvas pinkCanvas;

	PinkSoftBar(PinkCanvas pinkCanvas)
	{
		this.pinkCanvas = pinkCanvas;
	}

	public void paint(Graphics g, int leftBar, int midBar, int rightBar)
	{
		int BUTTON_X = SOFTBAR_X + 7;
		int BUTTON_Y = SOFTBAR_Y + 2;

		// Ʈٸ ׸...
		g.setColor(0x246daa);
		g.fillRect(SOFTBAR_X, SOFTBAR_Y, SOFTBAR_WIDTH, SOFTBAR_HEIGHT);

		g.setColor(0xffffff);
		//  ư
		if(leftBar >= 0)
		{
			switch(leftBar)
			{
				case XSOFTBAR_UP:
					g.drawString("", BUTTON_X, BUTTON_Y, g.LEFT | g.TOP);
					break;
					
				case XSOFTBAR_MENU:
					g.drawString("޴", BUTTON_X, BUTTON_Y, g.LEFT | g.TOP);
					break;
								
				case XSOFTBAR_JOIN:
					g.drawString("", BUTTON_X, BUTTON_Y, g.LEFT | g.TOP);
					break;

				case XSOFTBAR_CANCEL:
					g.drawString("", BUTTON_X, BUTTON_Y, g.LEFT | g.TOP);
					break;
			}
		}

		//  ư
		if(midBar >= 0)
		{
			BUTTON_X = SOFTBAR_X + SOFTBAR_WIDTH / 2;
		
			switch(midBar)
			{
				case XSOFTBAR_4ARROW:
					g.drawString("+", BUTTON_X, BUTTON_Y, g.HCENTER | g.TOP);
					break;
					
				case XSOFTBAR_2ARROW:
					g.drawString("|", BUTTON_X, BUTTON_Y, g.HCENTER | g.TOP);
					break;
			}
		}

		// 
		if(rightBar >= 0)
		{
			BUTTON_X = SOFTBAR_X + SOFTBAR_WIDTH - 6;
		
			switch(rightBar)
			{			
				case XSOFTBAR_ENTER:
					g.drawString("Ȯ", BUTTON_X, BUTTON_Y, g.RIGHT | g.TOP);
					break;

				case XSOFTBAR_CALL:
					g.drawString("ȭ", BUTTON_X, BUTTON_Y, g.RIGHT | g.TOP);
					break;
			}
		}
	}
}
