/**
 * <p>Title: MapEdit</p>
 * <p>Description: XList</p>
 * @author PinkRed
 * @version 0.5
 */
 
import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class XList
{

/*
** --------------------------------------------------------------------------------
**	Define 
** --------------------------------------------------------------------------------
*/

	// ٴ  ..Ϲ Ʈ ũ  1 ũ ϴµ. 
	// ̷ Ѱ ˾Ƽ...	
	public final static int LIST_PER_LINEHEIGHT	= 16;
	public final static int LIST_ITEM_WIDTH		= 14;	// Ʈ ڿ ڿ 

	public final static int TYPE_DEFAULT			= 1;
	public final static int TYPE_ITEM				= 2;

/*
** --------------------------------------------------------------------------------
**	 
** --------------------------------------------------------------------------------
*/

	int LIST_X;			// List X
	int LIST_Y;			// List Y
	int LIST_WIDTH;		// List Width
	int LIST_HEIGHT;		// List Height

	int MARGIN_LEFT;		// Margin  LEFT
	int MARGIN_RIGHT;		// Margin  RIGHT
	int MARGIN_TOP;			// Margin  TOP
	int MARGIN_BOTTOM;		// Margin  BOTTOM

	int firstLine;			//  ȭ鿡 ̴  Line
	int curLine;			//  õ Line
	int maxLine;			// Ʈ ü  

	int maxPerLine;		// LIST_HEIGHT  ִ  

	int list_anchor;		// Ÿ ɼ
	boolean list_yMove;	// List y Űܾ Ұ.


	char[][] list_text;		// Ʈ  迭
	XTileInfo[] xTileInfo;	// Ʈ  迭.
	char[] list_num = {'', '', '', '', '', '', '', '', '', '', '', '', '', '', ''};	// List  迭

	int fontColor = 0x000000;		// Ʈ Į
	int selfontColor = 0xffff00;	// õ Ʈ Į
	int barColor = 0x000000 ;		// ù Į


	// ũ 
	public final static int SCROLL_WIDTH 		= 6;		// ũ  
	public final static int SCROLLBAR_WIDTH 	= 5;		// ũ  
	public final static int SCROLLBAR_HEIGHT 	= 29;	// ũ  


	MapEditCanvas 	mapEditCanvas;

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    XList
**
**  Description:
** 	    
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	XList(MapEditCanvas mapEditCanvas)
	{
		this.mapEditCanvas = mapEditCanvas;
	}



/*
** -------------------------------------------------------------------------
**  Function:
** 	    setBounds
**
**  Description:
** 	    Ʈ  
**
**  Input:
** 	x : x
** 	y : y
** 	width : 
** 	height : 
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void setBounds(int x, int y, int width, int height)
	{
		LIST_X = x;
		LIST_Y = y;
		LIST_WIDTH = width;
		LIST_HEIGHT = height;

		// Height  ִ ٰ մϴ.
		// ںκ ȭ鿡  ̴ ٷ ϴ Դϴ.(̺κ ٰ ٽ)
		maxPerLine = LIST_HEIGHT / LIST_PER_LINEHEIGHT + ((LIST_HEIGHT % LIST_PER_LINEHEIGHT > 0)?1:0);
	}

	public void setBounds()
	{
		LIST_X = MapEditCanvas.LCD_X;
		LIST_Y = MapEditCanvas.LCD_Y;

		int curWidth = 0;
		LIST_WIDTH = 0;

		switch(list_anchor)
		{
			case TYPE_DEFAULT:
				for(int i = 0; i < maxLine; i++)
				{
					curWidth = Toolkit.DEFAULT_FONT.charsWidth(list_text[i], 0, list_text[i].length);
					if(LIST_WIDTH < curWidth)
						LIST_WIDTH =  curWidth;
				}
				
				LIST_WIDTH += LIST_ITEM_WIDTH + 2;
				break;

			case TYPE_ITEM:
				for(int i = 0; i < maxLine; i++)
				{
					curWidth = Toolkit.DEFAULT_FONT.stringWidth(xTileInfo[i].infoName);
					if(LIST_WIDTH < curWidth)
						LIST_WIDTH =  curWidth;
				}

				LIST_WIDTH += MapEditCanvas.TILE_WIDTH + 2;
				break;
		}

		LIST_HEIGHT = maxLine * LIST_PER_LINEHEIGHT + 2;

		// Height  ִ ٰ մϴ.
		// ںκ ȭ鿡  ̴ ٷ ϴ Դϴ.(̺κ ٰ ٽ)
		maxPerLine = LIST_HEIGHT / LIST_PER_LINEHEIGHT + ((LIST_HEIGHT % LIST_PER_LINEHEIGHT > 0)?1:0);
	}

/*
** -------------------------------------------------------------------------
**  Function:
** 	    setMargin
**
**  Description:
** 	    Ʈ Margin 
**
**  Input:
** 	top : .
** 	right : 
** 	bottom : ϴ
** 	left : .
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void setMargin(int top, int right, int bottom, int left)
	{
		MARGIN_TOP 		= top;
		MARGIN_RIGHT 	= right;
		MARGIN_BOTTOM 	= bottom;
		MARGIN_LEFT 	= left;

		// Margin  Height  ִ ٰ մϴ.		
		int list_height = LIST_HEIGHT - (MARGIN_TOP + MARGIN_BOTTOM);
		
		maxPerLine = list_height / LIST_PER_LINEHEIGHT + 
			((list_height % LIST_PER_LINEHEIGHT > 0)?1:0);
	}


/*
** -------------------------------------------------------------------------
**  Function:
** 	    setChars
**
**  Description:
** 	    Ʈ 迭  
**
**  Input:
** 	list : Ʈ 迭
** 	count : 迭 
** 	anchor : Ÿ ɼ( ʴ´ ׳ ɼ ɼ ̴.)
**
**  Return value:
**
** -------------------------------------------------------------------------
*/
	public void setChars(char[][] list, int count, int anchor)
	{
		int length = 0;
		int i = 0;

		// ó
		if(list == null || list.length < count || count <= 0)
		{
			throw new ArrayIndexOutOfBoundsException();
		}

		// list_text ʱȭ
		//  ش List ׳ Ѱ־  ۷ ޾
		// ̹  ش List  īؼ ̿Ѵ.
		// ׷Ƿ ۽ø ʱȭ ־ Ѵ.
		//  ִ. װ  ϴ ŸϷ ϸ ̴.
		if(list_text != null)
		{
			for(i = 0; i < maxLine; i++)
				list_text[i] = null;

			list_text = null;
		}

		//  ʱȭ
		firstLine = 0;
		curLine = 0;
		maxLine = count;
		list_anchor = anchor;

		list_text = new char[maxLine][];

		for(i = 0; i < maxLine; i++)
		{
			length = list[i].length;
			list_text[i] = new char[length];

			System.arraycopy(list[i], 0, list_text[i], 0, length);
		}
	}


	public void setString(String[] list, int count, int anchor)
	{
		int i = 0;

		// ó
		if(list == null || list.length < count || count <= 0)
		{
			throw new ArrayIndexOutOfBoundsException();
		}

		if(list_text != null)
		{
			for(i = 0; i < list_text.length; i++)
				list_text[i] = null;

			list_text = null;
		}

		//  ʱȭ
		firstLine = 0;
		curLine = 0;
		maxLine = count;
		list_anchor = anchor;

		list_text = new char[maxLine][];

		for(i = 0; i < maxLine; i++)
			list_text[i] = list[i].toCharArray();
	}


	public void setString(XTileInfo[] _xTileInfo, int count, int anchor)
	{
		int i = 0;

		// ó
		if(_xTileInfo == null || _xTileInfo.length < count || count <= 0)
		{
			throw new ArrayIndexOutOfBoundsException();
		}

		if(xTileInfo != null)
		{
			for(i = 0; i < xTileInfo.length; i++)
			{
				xTileInfo[i].infoTile = null;
				xTileInfo[i].infoName = null;
				xTileInfo[i] = null;
			}

			xTileInfo = null;
		}

		//  ʱȭ
		firstLine = 0;
		curLine = 0;
		maxLine = count;
		list_anchor = anchor;

		xTileInfo = _xTileInfo;
	}

/*
** -------------------------------------------------------------------------
**  Function:
** 	    keyPressed
**
**  Description:
**		key ̺Ʈ.
**
**  Input:
** 	keyCode : Ű.
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void keyPressed(int keyCode)
	{
		int list_height 	= LIST_HEIGHT - (MARGIN_TOP + MARGIN_BOTTOM);	// List  

		switch(keyCode)
		{
			case Canvas.KEY_UP:
				//   0 ...   .
				//  Ʈ øٰ ̻ ö ʰ ϴ 쵵 ִ.
				if(curLine <= 0)
				{
					//   .
					curLine = maxLine - 1;
					
					// ȭ ù°  
					// LIST_HEIGHT  ū .
					//  ο ȭ鿡 ִ ŭ .
					firstLine = (maxLine * LIST_PER_LINEHEIGHT <= list_height)?0:maxLine - maxPerLine;
				} else
				{		
					// ù°  ϳ  ø.
					if(firstLine > curLine - 1)
						firstLine--;

					//  ε  ø.
					curLine--;
				}
				
				// ߿ üũ..

				//  Ŀ   LIST_HEIGHT  ũ list_yMove־Ѵ.
				//   Ⱥ̴ ŭ  ø.
				// ̰ ù°ο  ø    .
				if((curLine + 1) * LIST_PER_LINEHEIGHT > list_height)
					list_yMove = true;

				// ϴ     list_yMove true Ǽ..
				// ü  ׷ ġ ÷    ߺ̰ Ѵ.
				// ̷  ù°  ణ ̰ ȴ. ׷ ٽ ù°  
				// Ϸ Ŀ ù°  ö ٷ Ѵ.
				if(list_yMove)
					list_yMove = curLine == firstLine?false:true;
				
				mapEditCanvas.setRefreshArea(LIST_X, LIST_Y, LIST_WIDTH, LIST_HEIGHT);
				mapEditCanvas.repaintArea();
				break;

			case Canvas.KEY_DOWN:
				//    ̸ ù° ̵Ѵ.
				if(curLine >= maxLine - 1)
				{
					firstLine = curLine = 0;
				}else
				{
					// ù°  Ų.
					if(firstLine + maxPerLine - 1 <= curLine)
						firstLine++;

					//   Ų.
					curLine++;
				}

				//  ̴.
				if((curLine + 1) * LIST_PER_LINEHEIGHT > list_height)
					list_yMove = true;

				//  ̴.
				if(list_yMove)
					list_yMove = curLine == firstLine?false:true;

				mapEditCanvas.setRefreshArea(LIST_X, LIST_Y, LIST_WIDTH, LIST_HEIGHT);
				mapEditCanvas.repaintArea();
				break;
		}
	}				

/*
** -------------------------------------------------------------------------
**  Function:
** 	    keyReleased
**
**  Description:
**		key ̺Ʈ.
**
**  Input:
** 	keyCode : Ű.
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void keyReleased(int keyCode)
	{
	}
	

/*
** -------------------------------------------------------------------------
**  Function:
** 	    paint
**
**  Description:
** 	    List  ׸.
**
**  Input:
** 	g : Graphics ü
**
**  Return value:
**
** -------------------------------------------------------------------------
*/
	public void paint(Graphics g)
	{	
		// List   ã´.
		// ⺻ ü   maxPerLine ۰ų    ü ǰ
		// ׷  ù°ο maxPerLine ŭ ؼ   Ѵ.
		int lastLine = (maxLine <= maxPerLine)?maxLine:
			((firstLine + maxPerLine  > maxLine)?maxLine:firstLine + maxPerLine);

		int i, k;
		int xTicker_x, xTicker_y, xTicker_width, xTicker_height;

		// Margin   Ʈ   ´.
		int list_x 		= LIST_X + MARGIN_LEFT;
		int list_y 		= LIST_Y + MARGIN_TOP;
		int list_width 	= LIST_WIDTH - (MARGIN_LEFT + MARGIN_RIGHT);
		int list_height 	= LIST_HEIGHT - (MARGIN_TOP + MARGIN_BOTTOM);

		int text_x;	// ڸ ׸ X
		int text_y;	// ڸ ׸ Y

		// Scroll  ׸ ȴ.
		//  Scroll ġ  ԽŰ ʴ´.(̰ ϰ ..)
//		boolean bDrawScroll = (maxLine * LIST_PER_LINEHEIGHT > LIST_HEIGHT)?true:false;

		// Scroll  쿡 LIST_WIDTH SCROLL_WIDTH .
//		if(bDrawScroll)
//			list_width -= SCROLL_WIDTH;

		//    
		g.setColor(0x000000);
		g.drawRect(LIST_X, LIST_Y, LIST_WIDTH, LIST_HEIGHT);
		g.setColor(0xffffff);
		g.fillRect(LIST_X, LIST_Y, LIST_WIDTH, LIST_HEIGHT);

		//    List  ׸.
		g.setClip(list_x, list_y, list_width, list_height);

		// List  õ ο  y ؾ ϴ  .
		// ڼ  KeyPressed ϰڽϴ.
		// y      ö Ѵ.
		// κ ̴  Ⱥ̴ ŭ  ø.
		if(list_yMove)
			list_y -= (maxPerLine * LIST_PER_LINEHEIGHT - list_height);

		for(i = firstLine, k = 0; i < lastLine; i++, k++)
		{
			text_x = list_x + 1;
			text_y = list_y + LIST_PER_LINEHEIGHT * k;

			if(k == (curLine - firstLine))
			{
				// Ticker ǥ .
				xTicker_x = text_x + LIST_ITEM_WIDTH;
				xTicker_y = text_y;
				xTicker_width = list_width - (1 + LIST_ITEM_WIDTH);
				xTicker_height = LIST_PER_LINEHEIGHT;
				
				// Ticker .
//				xTicker.setBounds(xTicker_x, xTicker_y, xTicker_width, xTicker_height);
//				mapEditCanvas.setRefreshArea(xTicker_x, xTicker_y, xTicker_width, xTicker_height);
//				xTicker.setChars(list_text[i]);
//				xTicker.setColor(barColor, selfontColor);
			
				//   ׸.
				g.setColor(barColor);
				g.fillRect(list_x, text_y, list_width, LIST_PER_LINEHEIGHT);


				//Ʈ  ׸
				switch(list_anchor)
				{
					case TYPE_DEFAULT:
						// Ʈ  ׸
						g.setColor(selfontColor);
						g.drawChar(list_num[i], text_x, text_y + (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) / 2, g.TOP|g.LEFT);
						text_x += LIST_ITEM_WIDTH;
						g.drawChars(list_text[i], 0, list_text[i].length, text_x, text_y + (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) / 2, g.TOP|g.LEFT);
						break;

					case TYPE_ITEM:
						mapEditCanvas.drawTile(g, xTileInfo[i].infoTile[0], text_x, text_y + (LIST_PER_LINEHEIGHT - MapEditCanvas.TILE_HEIGHT) / 2);
						text_x += MapEditCanvas.TILE_WIDTH + 1;

						g.setColor(selfontColor);
						g.drawString(xTileInfo[i].infoName, text_x, text_y + (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) / 2, g.TOP|g.LEFT);
						break;
				}
				
				continue;
			}


			//Ʈ  ׸
			switch(list_anchor)
			{
				case TYPE_DEFAULT:
					// Ʈ  ׸
					g.setColor(fontColor);
					g.drawChar(list_num[i], text_x, text_y + (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) / 2, g.TOP|g.LEFT);
					text_x += LIST_ITEM_WIDTH;
					g.drawChars(list_text[i], 0, list_text[i].length, text_x, text_y + (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) / 2, g.TOP|g.LEFT);
					break;

				case TYPE_ITEM:
					mapEditCanvas.drawTile(g, xTileInfo[i].infoTile[0], text_x, text_y + (LIST_PER_LINEHEIGHT - MapEditCanvas.TILE_HEIGHT) / 2);
					text_x += MapEditCanvas.TILE_WIDTH + 1;

					g.setColor(fontColor);
					g.drawString(xTileInfo[i].infoName, text_x, text_y + (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) / 2, g.TOP|g.LEFT);
					break;
			}
		}

		// ȭ鿡 ׸  ü  
		g.setClip(MapEditCanvas.LCD_X, MapEditCanvas.LCD_Y,
			MapEditCanvas.LCD_WIDTH, MapEditCanvas.LCD_HEIGHT);

		// Scroll  ׸ ȴ.
//		if(bDrawScroll)
//			drawScroll(g, maxLine, curLine);
	}


/*
** -------------------------------------------------------------------------
**  Function:
** 	    drawScroll
**
**  Description:
** 	    Scroll  ׸.
**
**  Input:
** 	g : Graphics ü
**	maxLine : ִ 
**	selLine :  õ .
**
**  Return value:
**
** -------------------------------------------------------------------------
*/

	public void drawScroll(Graphics g, int totLine, int selLine)
	{
		int scroll_height = LIST_HEIGHT;
		int scroll_x = LIST_X + LIST_WIDTH - SCROLL_WIDTH;
		int scroll_y = LIST_Y;

		int scrollBar_x = scroll_x;

		// ũ  Y ġ 
		int scrollBar_y = scroll_y + ((totLine <= 1)?0:(scroll_height - SCROLLBAR_HEIGHT - 2) * selLine / (totLine - 1));

		// ũ ׸
		g.setColor(0xff0000);
		g.fillRect(scroll_x + 1, scroll_y + 1, SCROLL_WIDTH - 1, scroll_height - 1);
		g.setColor(0xc166f4);
		g.drawRect(scroll_x, scroll_y, SCROLL_WIDTH, scroll_height - 1);

		// ũѹ ׸
		g.setColor(0x00ffff);
		g.fillRect(scrollBar_x + 1, scrollBar_y + 1, SCROLLBAR_WIDTH, SCROLLBAR_HEIGHT);
	}


/*
** --------------------------------------------------------------------------------
**  Function:
**	getSelect, getChars, getString
**
**  Description:
** 	     õ Ϳ Ͽ Ѵ.
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public int getSelect()
	{
		return curLine;
	}

	public char[] getChars()
	{
		char[] text = new char[list_text[curLine].length];

		System.arraycopy(list_text[curLine], 0, text, 0, list_text[curLine].length);
		
		return text;
	}

	public String getString()
	{
		return (new String(list_text[curLine]));
	}

	public int getTileNum()
	{
		if(list_anchor == TYPE_ITEM)
			return xTileInfo[curLine].infoTile[0];

		return -1;
	}

	public int getAnchor()
	{
		return list_anchor;
	}

	public XTileInfo getTile()
	{
		return xTileInfo[curLine];
			
	}
}
