import java.net.*;
import java.io.*;

public class server extends Thread
{	
	ServerSocket serverSocket;
	Socket clientSocket;
	
	boolean isConnect = false;

	DataOutputStream dataOutputStream = null;
	DataInputStream dataInputStream = null;

	server()
	{
		int port = 2000;
		
		try
		{
			serverSocket = new ServerSocket(port);
		
			System.out.println("Server" + serverSocket.getInetAddress() + port + "Watting Connect at Port");

			clientSocket = serverSocket.accept();

			System.out.println(" Ǿϴ.");

			this.start();
		}catch(IOException e) {System.out.println(e);}

	}

	public void run()
	{
		isConnect = true;

		try
		{
			dataOutputStream = new DataOutputStream(clientSocket.getOutputStream());
			dataInputStream = new DataInputStream(clientSocket.getInputStream());

			while(isConnect)
			{
				switch(dataInputStream.readInt())
				{
					case 1:
						push_Num1();
						break;
					case 2:
						push_Num2();
						break;
					case 3:
						push_Num3();
						break;
					case 4:
						isConnect = false;
						break;
				}
			}

			System.out.println(".");

			dataOutputStream.close();
			dataInputStream.close();
			serverSocket.close();
		}catch(IOException e)
		{
			isConnect = false;
			System.out.println(" ϴ.");
		}
	}

	public void push_Num1()
	{
		System.out.println("push_Num1 - Start");
		
		try
		{
			dataOutputStream.writeUTF("push_Num1 : ũ NETWORK ");
			dataOutputStream.flush();
		}catch(Exception e){System.out.println(e);}

		System.out.println("push_Num1 - End");		
	}

	public void push_Num2()
	{
		System.out.println("push_Num2 - Start");

		try
		{
			String result;

			FileInputStream fileInputStream = new FileInputStream("1.png");
			byte[] buf = new byte[fileInputStream.available()];
			fileInputStream.read(buf);
			fileInputStream.close();

			dataOutputStream.writeInt(buf.length);
			dataOutputStream.write(buf, 0, buf.length);
			dataOutputStream.flush();

			result = dataInputStream.readUTF();
			System.out.println("result : " + result);

			fileInputStream.close();
		}catch(IOException e) 
		{
			System.out.println(e);
		}

		System.out.println("push_Num2 - End");				
	}

	public void push_Num3()
	{
		String test = "push_Num3 ũ NETWORK";
		byte[] buf = test.getBytes();
		int bSize = 0;

		System.out.println("push_Num3 - Start");

		try
		{
			dataOutputStream.writeInt(buf.length);
			dataOutputStream.write(buf, 0, buf.length);
			dataOutputStream.flush();

			buf = null;

			bSize = dataInputStream.readInt();
			buf = new byte[bSize];


			dataInputStream.read(buf); 

			System.out.println("buf : " + (new String(buf)));
		}catch(IOException e) 
		{
			System.out.println(e);
		}

		System.out.println("push_Num3 - End");		
	}


	public static void main(String[] args)
	{
		server sc = new server();
	}
}
