import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class TorusEngine
{

/*
** -----------------------------------------------------------------
**	define 	    
** -----------------------------------------------------------------
*/

	//  ̹ ȼ ũ  Ǿִ.
	// SLOT
	public final static int SLOT_UBAR_WIDTH 	= 12;	// SLOT Torus   
	public final static int SLOT_UBAR_HEIGHT = 12;	// SLOT Torus   .
	
	public int SLOT_WIDTH;		// ü  
	public int SLOT_HEIGHT;		// ü  .
	public int SLOT_X;		//  X
	public int SLOT_Y;		//  Y

	// Screw
	// Bar
	public final static int SCREWBAR_WIDTH	= 11;	//    
	public final static int SCREWBAR_HEIGHT	= 4;		//    
	public int SCREWBAR_X ;						//    X
	public int SCREWBAR_Y;						//    Y

	// Pin
	public final static int SCREWPIN_WIDTH	= 11;	//   
	public int SCREWPIN_HEIGHT;					//   
	public int SCREWPIN_X ;						//   X
	public int SCREWPIN_Y;						//   Y

	// Torus
	public final static int TORUS_WIDTH 		= 11;	// ϳ Torus 
	public final static int TORUS_HEIGHT 		= 11;	// ϳ Torus .
	public final static int TORUS_SLOT_HEIGHT 	= 3;		// Կ  Torus .
	public final static int TORUS_NOMOTION		= 26;	// Կ  Torus ̹ Yǥ.
	public final static int TORUS_MOTION 			= 4;		// 4 ִϸ̼  ִ.


	public final static int MAX_SCORE = 6;			//  ڸ.

/*
** -----------------------------------------------------------------
**	Class 	    
** -----------------------------------------------------------------
*/

	TorusCanvas 	tCanvas;

	//  Torus ü 
	//  ش  ŭ   ޸   Ͽ
	// ü ִ  Ѵ. ׷Ƿ  ö󰡴    ϴ.
	//  ̰ 󸶳 ӵ  𸣰..ǹ Ҽ ִ. ̤
	TorusRing[]	tRing = new TorusRing[16];


/*
** -----------------------------------------------------------------
**	 	    
** -----------------------------------------------------------------
*/

	// SLOT .
	// ̸ 迭 ִ  ҴϿ ӵ  Ѵ.
	//  ̷ ش  ִ ּ  ġ Ȯ ؾ Ѵ.
	// ⼭  .. Torus ̴  ǹѴ.
	int[][] TORUS_SLOT = new int[12][16];	// SLOT 2 迭.
	int[] slotCurLine = new int[16];			//   SLOT ׿ ִ ִ .
	int[] slotDelLine = new int[16];			//   Ѵ.
	int slotMaxLine;						// SLOT   ִ  .
	int slotCount;						// SLOT 

	// Screw .
	int[] TORUS_SCREW = new int[12];	// .(ִ )
	int screwCurStatck;		//   ġ
	int maxOfscrewStack;		// ش   Screw  Torus ִ .
	int screwPos;			//  ġ

	int curLevel;				//  ..
	int scoreTorus;			//  .

	boolean bDelLine;			//   .
	boolean allClear;			// All Clear  


/*
** -----------------------------------------------------------------
**  Function:    
** 	    TorusEngine
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	TorusEngine(TorusCanvas tCanvas)
	{
		this.tCanvas = tCanvas;
	}



/*
** -----------------------------------------------------------------
**  Function:    
** 	    initStage
**
**  Description: 
** 	     ʱȭ.
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void statgeInit(int level)
	{
		// LEVEL .
		curLevel = level;

		//////// SLOT ʱȭ...
		// SLOT  .
		slotCount = TorusCanvas.TORUS_STAGE[curLevel][0];

		// SLOT  Torus .
		slotMaxLine = TorusCanvas.TORUS_STAGE[curLevel][1];

		// Screw  Torus .
		maxOfscrewStack = TorusCanvas.TORUS_STAGE[curLevel][2];

		// SLOT ʱȭ
		// ش SLOT ̿Ͽ  ġ Xǥ .
		SLOT_WIDTH = SLOT_UBAR_WIDTH * slotCount + 1;
		SLOT_X = TorusCanvas.LCD_X + (TorusCanvas.LCD_WIDTH - SLOT_WIDTH) / 2;


		///////// Screw ʱȭ.
		// Screw  ..
		//  = (Pin) + (Bar)   ̹  Ѵ.
		// Screw Bar X, Y ǥ 
		screwCurStatck = 0;
		
		SCREWBAR_Y = TorusCanvas.LCD_Y + TorusCanvas.LCD_HEIGHT - 5 - SCREWBAR_HEIGHT;
		SCREWBAR_X = SLOT_X + 1;

		// Screw Pin ʱȭ.
		// Screw ̿ X, Yǥ 
		// ̴   ٸ.
		SCREWPIN_HEIGHT = maxOfscrewStack * TORUS_SLOT_HEIGHT;
		SCREWPIN_Y = SCREWBAR_Y - SCREWPIN_HEIGHT;
		SCREWPIN_X = SCREWBAR_X;

		screwCurStatck = 0;

		// SLOT  ʱȭ
		SLOT_HEIGHT = SLOT_UBAR_HEIGHT + slotMaxLine * TORUS_SLOT_HEIGHT;// SLOT  Torus ̴ 3̴.
		SLOT_Y = SCREWPIN_Y - SLOT_HEIGHT;

		//  Torus ʱȭ.
		for(int i = 0; i < slotCount; i++)
		{
			if(tRing[i] == null)
				tRing[i] = new TorusRing(tCanvas);
			
			tRing[i].setStaus(i);

			//  Զ ʱȭ Ų.
			slotCurLine[i] = 0;
		}
	}


/*
** -----------------------------------------------------------------
**  Function:    
**		- screwLevelUp
**
**  Description: 
**		- 簡 Ѵ.(Torus  ִ  پ.)
**
**  Input:	
**
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void screwLevelUp()
	{
		// Screw  Torus  ϳ پ.
		maxOfscrewStack--;
		
		// Screw Bar ʱȭ.
		SCREWBAR_Y -= TORUS_SLOT_HEIGHT;

		// Screw Pin ʱȭ.
		SCREWPIN_HEIGHT -=  TORUS_SLOT_HEIGHT;

		// Screw Torus    Torus .
		if(screwCurStatck >= maxOfscrewStack)
			screwCurStatck--;
	}

/*
** -----------------------------------------------------------------
**  Function:    
**		- slotLevelUp
**
**  Description: 
**		-  Ѵ.
**
**  Input:	
**
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public void slotLevelUp()
	{
		statgeInit(++curLevel);
	}
	
/*
** -----------------------------------------------------------------
**  Function:    
**		- slotPut
**
**  Description: 
**		- Slot ť Put
**
**  Input:	
**		- curSlot :  õ .
**		- torusColor :  Կ  ν .
**
**  Return value:
**		- , .
**	    
** -----------------------------------------------------------------
*/

	public boolean slotPut(int curSlot, int torusColor)
	{
		//  ,    , ִ  Ѿ 
//		if(slotCurLine[curSlot] >= slotMaxLine || curSlot >= slotCurLine.length || 
//			torusColor > TorusCanvas.MAX_COLOR)
//			return false;

		// δ Ʒ  ϸ .
		if(slotCurLine[curSlot] >= slotMaxLine)
			return false;
		
		// SLOT ״´.
		TORUS_SLOT[curSlot][slotCurLine[curSlot]++] = torusColor;

		return true;
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- slotGet
**
**  Description: 
** 	    	- Slot ť Get
**
**  Input:	
**		- curSlot :  õ .
** 
**  Return value:
**		- 0 : ̻..߰..
**		- 1 Over : Color Value
**	    
** -----------------------------------------------------------------
*/

	public int slotGet(int curSlot)
	{
		//  .
//		if(TORUS_SLOT[curSlot][0] == 0 || curSlot >= slotCurLine.length)
//			return 0;

		// δ Ʒ  ϸ .
		if(TORUS_SLOT[curSlot][0] == 0)
			return 0;

		//  ؿ ִ Torus Į ´.
		int colorValue = TORUS_SLOT[curSlot][0];

		// ĭ ش.
		System.arraycopy(TORUS_SLOT[curSlot], 1, TORUS_SLOT[curSlot], 0, slotCurLine[curSlot]--);
			
		return colorValue;
	}
	


/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- slotPush
**
**  Description: 
** 	    	- Slot  Push
**
**  Input:	
**		- curSlot :  õ .
**		- torusColor :  Կ  ν .
** 
**  Return value:
**		- , .
**	    
** -----------------------------------------------------------------
*/
	public boolean slotPush(int curSlot, int torusColor)
	{
		//  ,    , ִ  Ѿ 
//		if(slotCurLine[curSlot] >= slotMaxLine ||curSlot >= slotCurLine.length || 
//			torusColor > TorusCanvas.MAX_COLOR)
//			return false;

		// δ Ʒ  ϸ .
		if(slotCurLine[curSlot] >= slotMaxLine)
			return false;
		

		for(int i = slotCurLine[curSlot]++; i >= 1; i--)
			TORUS_SLOT[curSlot][i] = TORUS_SLOT[curSlot][i -1];

		TORUS_SLOT[curSlot][0] = torusColor;
		
		return true;
	}




/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- screwPush
**
**  Description: 
** 	    	- Screw  Push
**
**  Input:	
**		- curSlot :  õ .
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void screwPush(int curSlot)
	{
		if(screwCurStatck >= maxOfscrewStack)
			return;

		// SLOT  GetѴ.
		int popColor = slotGet(curSlot);
		
		if(popColor > 0)
			TORUS_SCREW[screwCurStatck++] = popColor;
	}

/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- screwPop
**
**  Description: 
** 	    	- Screw  Pop
**
**  Input:	
**		- curSlot :  õ .
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public void screwPop(int curSlot)
	{
		if(screwCurStatck <= 0)
			return;

		// SLOT PushѴ.
		if(slotPush(curSlot, TORUS_SCREW[screwCurStatck - 1]))
			TORUS_SCREW[--screwCurStatck] = 0;
	}


/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    deleteLine
**
**  Description: 
** 	    - Ѷ .(   ΰ ߽ ϸ  .)
**
**  Input:	
** 
**  Return value:
**	    
** --------------------------------------------------------------------------------
*/

	public /*synchronized*/ boolean delLine()
	{
 		int i = 0, j = 0, k = 0;
		boolean bDel = false;

		int torusColor = 0;
		int countMinSlot = 255;

		for(i = 0; i < slotCount; i++)
		{	
			//  ѽ̶  .
			if(slotCurLine[0] < 1)
				return bDel;
			else
			{
				// ׷    ׿ִ  ˾Ƴ.
				if(slotCurLine[i] < countMinSlot)
					countMinSlot = slotCurLine[i];
			}
		}

		//   ִ Ըŭ ϸ ȴ.
		for(i = 0, k = 0; i < countMinSlot; i++)
		{
			// ù° Կ ִ  Ѵ.
			torusColor = TORUS_SLOT[0][i];
			bDel = true;
			slotDelLine[k] = -1;
			
			for(j = 0; j < slotCount; j++)
			{
				//  ٸ    Ѿ.
				if(torusColor != TORUS_SLOT[j][i])
				{
					bDel = false;
					break;
				}
			}

			//   쿡   Ѵ.
			if(bDel)
				slotDelLine[k++] = i;
		}

		//    Ѵٸ..
		if(k > 0)
		{
			// .
			for(i = 0; i < k; i++)
			{
				for(j = 0; j < slotCount; slotCurLine[j]--, j++)
					System.arraycopy(TORUS_SLOT[j], slotDelLine[i] + 1, TORUS_SLOT[j], slotDelLine[i], slotCurLine[j] - slotDelLine[i]);

				// Torus  Ŀ    ű.
				scoreTorus += ((curLevel + 1) * 10 * TorusCanvas.GAME_LEVEL);
			}

			allClear = true;

			// All Clear ü Torus 츦 ǹϸ
			//   .
			// ̷ ȭ鿡 All Clear ָ .
			//  ̹ ִ.   غ  ϴ.
			for(i = 0; i < slotCount; i++)
			{
				if(screwCurStatck > 0 || slotCurLine[i] > 0)
				{
					allClear = false;
					break;
				}
			}

			if(allClear)
				scoreTorus += (curLevel + 1) * 100;
			
			bDel = true;
		}else
			bDel = false;

		return bDel;
	}




/*
** -----------------------------------------------------------------
**  Function:    
** 	    drawSlotTorus
**
**  Description: 
** 	    Slot, Torus ׸.
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void drawSlotTorus(Graphics g)
	{
		int i = 0, j = 0;

		// Torus ׷ ġ .
		int torusWidth = TORUS_WIDTH + 1;
		int torusHeight = 3;
		int torusX = SLOT_X + 1;
		int torusY = SLOT_Y + SLOT_HEIGHT - torusHeight;

		// drawSlot
		// ó Ѱ ̹  for  ׸ 
		// ޸𸮸   ʴ ̶ ϰ ߽ϴ.
		tCanvas.g2.drawImage(SLOT_X, SLOT_Y,
			tCanvas.imgSlot, 0, 0,
			SLOT_WIDTH, SLOT_HEIGHT, Graphics2D.DRAW_COPY);

		// drawTorus
		// ش Slot(2 迭)  ȿ ׿ ִ Torus ׸.
		for(i = 0; i < slotCount; i++)
		{
			// ش Կ ׿ִ Torus.
			for(j = 0; j < slotCurLine[i]; j++)
			{
				tCanvas.g2.drawImage(torusX + torusWidth * i,
					torusY - torusHeight * j,
					tCanvas.imgTorus,
					(TORUS_SLOT[i][j] - 1) * TORUS_WIDTH, TORUS_NOMOTION,
					TORUS_WIDTH, torusHeight, Graphics2D.DRAW_COPY);
			}
		}
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    drawScrewTorus
**
**  Description: 
** 	    Screw, Torus ׸.
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void drawScrewTorus(Graphics g)
	{
		int screwWidth = SCREWBAR_WIDTH + 1;

		// Back Color
		// Screw ̴ ϴ   ĥѴ.
		g.setColor(0x000000);
		g.fillRect(SLOT_X, SCREWPIN_Y, SLOT_WIDTH, SCREWPIN_HEIGHT + SCREWBAR_HEIGHT);

		// drawBarScrew
		g.drawImage(tCanvas.imgScrewBar, 
			SCREWBAR_X + screwPos * screwWidth, SCREWBAR_Y, g.LEFT | g.TOP);

		// drawPinScrew
		tCanvas.g2.drawImage(SCREWPIN_X + screwPos * screwWidth, SCREWPIN_Y,
			tCanvas.imgScrewPin, 0, 0,
			SCREWPIN_WIDTH, SCREWPIN_HEIGHT, Graphics2D.DRAW_COPY);

		// drawTorus
		int torusX = SCREWBAR_X + screwPos * screwWidth;
		int torusY = SCREWPIN_Y + SCREWPIN_HEIGHT - TORUS_SLOT_HEIGHT;

		// Screw  ׿ִ Torus ׸.
		for(int i = 0; i < screwCurStatck; i++)
		{
			tCanvas.g2.drawImage(torusX, torusY - TORUS_SLOT_HEIGHT * i,
				tCanvas.imgTorus,
				(TORUS_SCREW[i] - 1) * TORUS_WIDTH, TORUS_NOMOTION, 
				TORUS_WIDTH, TORUS_SLOT_HEIGHT, Graphics2D.DRAW_COPY);
		}
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    drawScore
**
**  Description: 
** 	     ׸.
**
**  Input:	
** 		- bSize : true : ū  , false :   .
**
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void drawScore(Graphics g, boolean bSize)
	{
		int score = scoreTorus;

		if(bSize)
		{
			for(int i = 0; i < MAX_SCORE; i++, score /= 10)
				tCanvas.g2.drawImage(TorusCanvas.LCD_X + TorusCanvas.LCD_WIDTH  / 2 + 17 - 9 * i, TorusCanvas.LCD_Y + 30,
					tCanvas.imgLNum, 9 * (score % 10), 0, 9, 12, Graphics2D.DRAW_COPY);
		}else
		{
			for(int i = 0; i < MAX_SCORE; i++, score /= 10)
				tCanvas.g2.drawImage(TorusCanvas.LCD_X + TorusCanvas.LCD_WIDTH  / 2 + 11 - 6 * i, TorusCanvas.LCD_Y + 2,
					tCanvas.imgSNum, 6 * (score % 10), 0, 6, 8, Graphics2D.DRAW_COPY);
		}
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    paint
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void paint(Graphics g)
	{
		// Ǵ   
		if(bDelLine)
		{
			//  Ǹ Slot ٽ ׸.
			if(delLine())
				drawSlotTorus(g);
			
			bDelLine = false;
		}
	
		//  Torus ׸.
		for(int i = 0; i < slotCount; i++)
		{
			switch(tRing[i].paint(g))
			{
				// ӿ.
				case -1:
					tCanvas.gameOver();
					return;

				// Torus  
				// ̰ų..Ҷ Torus   ȴ.
				case 1:
					bDelLine = true;

					// Torus   ׸  .
					// Slot ׸.
					drawSlotTorus(g);
					break;
			}
		}

		// Score ׸.
		drawScore(g, false);
	}

/*
** -----------------------------------------------------------------
**  Function:    
** 	    keyPressed
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public void keyPressed(int keyCode)
	{
		// ¿ Ű 쿡 XDisplay.refresh() Ѵ.
		switch(keyCode)
		{
			// Screw ִ  SLOT ø.
			case Canvas.KEY_UP://	= 141;
				screwPop(screwPos);

				// Torus Ʒ ̰ų  
				//   Ѵ.
				//  ų ø Torus  ʴ 찡 ִ.
				// ׷ 쿡 ⿡ delLine() ־ Ѵ.
				delLine();
//				bDelLine = true;

				// ӵ鿡 ¿ϸ   üӵ 
				drawScrewTorus(Toolkit.graphics);
				drawSlotTorus(Toolkit.graphics);
				XDisplay.refresh(SLOT_X, SLOT_Y, SLOT_WIDTH, SLOT_HEIGHT + SCREWPIN_HEIGHT + SCREWBAR_HEIGHT);
				break;

			// Screw · δ.
			//    쿡  ̻  Ѵ.
			case Canvas.KEY_LEFT://	= 142;
				screwPos = (--screwPos < 0)?0:screwPos;

				// ӵ鿡 ¿ϸ   üӵ 
				drawScrewTorus(Toolkit.graphics);
				XDisplay.refresh(SCREWPIN_X, SCREWPIN_Y, SLOT_WIDTH, SCREWPIN_HEIGHT + SCREWBAR_HEIGHT);
				break;

			// Screw  δ.
			//    쿡  ̻  Ѵ.
			case Canvas.KEY_RIGHT://	= 145;
				screwPos = (++screwPos >= slotCount)?
					slotCount - 1:screwPos;

				// ӵ鿡 ¿ϸ   üӵ 
				drawScrewTorus(Toolkit.graphics);
				XDisplay.refresh(SCREWPIN_X, SCREWPIN_Y, SLOT_WIDTH, SCREWPIN_HEIGHT + SCREWBAR_HEIGHT);
				break;

			// SLOT ִ  Screw .
			case Canvas.KEY_DOWN://	= 146;
				screwPush(screwPos);

				// Torus Ʒ ̰ų  
				//   Ѵ.
				//  ų ø Torus  ʴ 찡 ִ.
				// ׷ 쿡 ⿡ delLine() ־ Ѵ.
				delLine();
//				bDelLine = true;

				// ӵ鿡 ¿ϸ   üӵ 
				drawScrewTorus(Toolkit.graphics);
				drawSlotTorus(Toolkit.graphics);
				XDisplay.refresh(SLOT_X, SLOT_Y, SLOT_WIDTH, SLOT_HEIGHT + SCREWPIN_HEIGHT + SCREWBAR_HEIGHT);
				break;
		}
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    keyReleased
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public void keyReleased(int keyCode)
	{
	}
}
