import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.io.*;

import com.xce.lcdui.*;
import com.skt.m.*;
import com.xce.io.*;

public class TorusMIDlet extends MIDlet
{

/*
** -----------------------------------------------------------------
**	 
** -----------------------------------------------------------------
*/
	public final static String TORUS_FILE_INFO	= "/torusInfo.txt";

	Display display;				// Display 
	TorusCanvas tCanvas;			// Canvas 

	

/*
** -----------------------------------------------------------------
**  Function:
** 	    startApp
**
**  Description:
** 	    ø̼ ۵Ǹ 
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/

	public void startApp()
	{
		Device.setBacklightEnabled(false);
		BackLight.on(0);
	
		display = Display.getDisplay(this);
		tCanvas = new TorusCanvas(this);
		display.setCurrent(tCanvas);

		TorusCanvas.nameNscore = readInfo();
	}


/*
** -----------------------------------------------------------------
**  Function:
** 	    pauseApp
**
**  Description:
** 	    ø̼  ȣ(  )
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/
	public void pauseApp() {}

/*
** -----------------------------------------------------------------
**  Function:
** 	    resumeApp
**
**  Description:
** 	    ø̼ pauseApp() Ŀ  Ҷ ȣ(  )
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/

	public void resumeApp(){}

/*
** -----------------------------------------------------------------
**  Function:
** 	    destroyApp
**
**  Description:
** 	    ø̼  ɶ ȣ
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/
	public void destroyApp(boolean con){}

/*
** -----------------------------------------------------------------
**  Function:
** 	    readInfo
**
**  Description:
**		- ְ  о´.
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/

	public String readInfo()
	{
		String info = null;
		
		try
		{
			if(XFile.exists(TORUS_FILE_INFO))
			{
				XFile xFile = new XFile(TORUS_FILE_INFO, XFile.READ);
				
				byte[] lenBuf = new byte[xFile.available()];
			
				xFile.read(lenBuf, 0, lenBuf.length);
				xFile.close();
				xFile = null;

				info = new String(lenBuf);
			}
		}catch(Exception e){}

		return info;
	}


/*
** -----------------------------------------------------------------
**  Function:
** 	    writeInfo
**
**  Description:
**		- ְ  Ѵ.
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/

	public void writeInfo(String name, int score)
	{
		if(name == null)
			name = "ũ";

		try
		{
			XFile xFile = null;

			byte[] lenBuf = (name + ":" + score).getBytes();
		
			xFile = new XFile(TORUS_FILE_INFO, XFile.WRITE);
			xFile.write(lenBuf, 0, lenBuf.length);
			xFile.close();
			xFile = null;
			lenBuf = null;
		}catch(Exception e){}
	}


}
